/***************************************************************************
 *   Copyright (C) 2010 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <unistd.h>
#include "common.h"

// Check that a dataset file exists
int main(int argc, char *argv[])
{
    char datad[4096], file_name[1024], *home, path[8192], data_root[8192];
    FILE *f, *out_file;
    bool found = true;

    // Test enough parameters
    if (argc < 3) {
        printf("checkfile problem parameters\n");
        exit(1);
    }

    // Read parameters file for directory info
    // Open file
    if ((f = fopen(argv[2], "r")) == NULL)
        exit(1);
    if ((out_file = fopen("/dev/null", "w")) == NULL)
        exit(1);

    LoadString(f, "Data directory", "Data/MachineLearning/Classification", datad, out_file);
    fclose(f);
    fclose(out_file);

    // Check dataset file
    // Load data
    home = getenv("HOME");
    sprintf(data_root, "%s/%s", home, datad);

    // Training and test file
    sprintf(file_name, "%s.train", argv[1]);
    if (!FindFile(file_name, data_root, path))
        found = false;

    sprintf(file_name, "%s.gen", argv[1]);
    if (!FindFile(file_name, data_root, path))
        found = false;

    if (found)
        exit(1);
    else
        exit(0);
}

void OnErrorExit(int id, char *message)
{
    char *codes[] = {"No error", "Unspecified error", "Cannot open input file", "Cannot allocate memory", "Read failed"};

    printf("%s: %s\n", codes[id], message);

    exit(id);
}














