/***************************************************************************
 *   Copyright (C) 2019 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// Set defaults values for ALL parameters
#include "typex.h"
#include "abandoned.h"

void SetDefaultsParameterValues(t_Parameters *parm)
{
    // Integer values
    parm->add_k_neighbors = 0;
    parm->boost_based_filter_noise_k = 3;
    parm->cache_size = 0;
    parm->chc_generations = 1000;
    parm->chc_minimum_distance_factor = 4.0;
    parm->chc_size = 100;
    parm->chc_subpop_minimum_distance_factor = 4;
    parm->cv_folds = 10;
    // parm->democratic_rounds = 10;
    parm->demo_eval_rounds = 0;
    parm->demo_max_features = 0;
    parm->iblr_k = 5;
    parm->demo_max_strata = 0;
    parm->dimension = 0;
    parm->duplicate_features_ratio = 1;
    parm->easy_si = 10;
    parm->easy_t = 3;
    parm->eda_cycles_max = 50;
    parm->eda_lambda = 100;
    parm->pptc_k = 5;
    parm->eda_mu = 15;
    parm->eda_rho = 15;
    parm->evosmote_use_majority_threshold = 5;
    parm->ps_labels_bound = 10;
    parm->dmlknn_delta = 1;
    parm->ensemble_size = 30;
    parm->mlksnn_rounds = 1;
    parm->epoch_size = 32;
    parm->sifs2_add_group_size = 1;
    parm->eval_folds = 10;
    parm->eval_subset_size = 1000;
    parm->mlforest_ntrees = 50;
    parm->ibt_multiboost_I = 10;
    parm->lr_epochs = 1000;
    parm->ml_max_ioversampling_ratio = 0;
    parm->evaluation_subset_size = 1000;
    parm->lamlknn_min_n_clusters = 3;
    parm->lamlknn_max_n_clusters = 10;
    parm->external_subset_size = 1000;
    parm->external_subspace_size = 0;
    parm->ex_un_s_i = 5;
    parm->fasta_seq_length = 0;
    parm->mlmlp_hidden_nodes = 0;
    parm->fasta_seq_offset = 0;
    parm->fb_mt = 1000;
    parm->lamlknn_n_clusters = 5;
    parm->floating_attempts = 50;
    parm->fs_threshold_step = 1;
    parm->generations = 1000;
    parm->grnn_nodes = 50;
    parm->chc_max_reinit_attempts = 0;
    parm->imoea_seconds = 0;
    parm->imoea_seconds = 10;
    parm->individuals = 100;
    parm->inputs = -1;
    parm->instances_per_subpop = 0;
    parm->internal_subset_size = 0;
    parm->external_subset_size = 0;
    parm->internal_subspace_size = 0;
    parm->is_epochs = 100;
    parm->is_threshold_step = 1;
    parm->NBC_intervals = 100;
    parm->k = 1;
    parm->three_way_minus1_prob = 0.1;
    parm->k_bits = 3;
    parm->evosmote_noise_mutation_k = 5;
    parm->kernel = 0;
    parm->optiondt_O = 10;
    parm->optiondt_l = 2;
    parm->kmeans_max_iterations = 1000;
    parm->knn = 1;
    parm->knn_folds = 10;
    parm->kscbf_k = 10;
    parm->ps_b = 2;
    parm->ps_p = 1;
    parm->k_t = 1;
    parm->leave_no_neighbors_unchanged = 0;
    parm->lfb_bite_size = 1000;
    parm->lfb_iterations = 250;
    parm->lfb_subset_size = 10000;
    parm->localk_bs_n = 0;
    parm->localk_bs_n = 10;
    parm->localk_lambda = 3;
    parm->localk_max_k = 100;
    parm->rakel_k = 3;
    parm->rakel_m = 7;
    parm->localk_min_k = 1;
    parm->localk_nfolds = 10;
    parm->localk_repetitions = 1;
    parm->isfs_n_bites = 1;
    parm->lvf_iter = 100000;
    parm->homer_max_depth = 10;
    parm->m = 0;
    parm->mabuse_sort_by_weighted_mi_limit = 0;
    parm->max_dimension = 0;
    parm->max_evaluations = 0;
    parm->max_features_for_focus = 10;
    parm->max_fsel_thresholds = 0;
    parm->maximum_number_of_thresholds = 0;
    parm->mltree_depth = 10;
    parm->maximum_training_set_size = 0;
    parm->max_inputs = -1;
    parm->reinitalize_after_gs_no_improvement = 0;
    parm->max_isel_thresholds = 0;
    parm->max_ifsel_thresholds = 0;
    parm->evosmote_wrapper_eval_interval = 0;
    parm->max_k = 100;
    parm->max_n_minority_thresholds = 0;
    parm->max_nodes = 25;
    parm->max_n_thresholds = 0;
    parm->max_instances = 0;
    parm->micibm_k = -1;
    parm->minimum_instances = 0;
    parm->min_iterations = 0;
    parm->min_k = 1;
    parm->min_post_k = 1;
    parm->min_subset_size = 0;
    parm->minus_r = 1;
    parm->mlknn_k = 1;
    parm->smlknn_k = 1;
    parm->mlksnn_ls_steps = 100;
    parm->multiboost_reinit_iterations = 10;
    parm->nda_k = 0;
    parm->n_electors = 1;
    parm->eps_size = 30;
    parm->n_epochs = 2000;
    parm->nlp_attempts = 1;
    parm->nlp_epochs = 2000;
    parm->elm_a = 1.0;
    parm->elm_b = 0.6666;
    parm->nodes = 10;
    parm->np = 10;
    parm->nsr_n = 2;
    parm->nsr_p = 2;
    parm->Npc = 25;
    parm->nsp = 10;
    parm->cdn_I = 1000;
    parm->cdn_Ic = 100;
    parm->n_subpops = 0;
    parm->show_progress = 0;
    parm->n_thresholds = 0;
    parm->best_individual_fitness_improvement_generations = 0;
    parm->plus_l = 3;
    parm->plus_l = parm->minus_r = 1;
    parm->populate_copies_per_instance = 0;
    parm->populate_number_of_neighbors = 0;
    parm->population_size = 100;
    parm->positive_class = -1;
    parm->presample_subset_size = 1000;
    parm->projection_subspace_minimum_size = 3;
    parm->projection_subspaces = 1;
    parm->projection_subspace_size = 0;
    parm->random_sampling_for_threshold_evaluation_min_size = 10000;
    parm->rmhc_fp1_iterations = 1000;
    parm->mlksnn_window_size = 5;
    parm->relief_k = 10;
    parm->reweightboost_r = 5;
    parm->rmhc_iterations = 1000;
    parm->rmhc_m = 3;
    parm->ecc_T = 10;
    parm->sampling_size = 0;
    parm->scca_iterations = 100;
    parm->sifs2_sampling_size_for_performance = 0;
    parm->sifs2_sampling_size = 0;
    parm->sifs2_stratum_size = 0;
    parm->scca_proj_iterations = 10;
    parm->second_chances = 1;
    parm->seed = 0;
    parm->seq_length = 100;
    parm->seq_offset = 0;
    parm->smote_k = 3;
    parm->smote_N = 2;
    parm->stratum_size = 1000;
    parm->subpop_size = 100;
    parm->subset_size = 0;
    parm->subspace_size = 0;
    parm->svm_d = 1;
    parm->svm_hktype = 0;
    parm->svm_offset = 0;
    parm->svm_type = 0;
    parm->t = 1;
    parm->th_eval_n_iterarions = 1;
    parm->smote_undersampling_ratio = 0;
    parm->mlrs_k = 10;
    parm->update_w_n_iterarions = 1;
    parm->verbose = -1;
    parm->TRIALS = 1;
    parm->svm_type = 0;
    parm->kernel = 0;
    parm->svm_d = 1;
    parm->cache_size = 10000;
    parm->test_1nn_slaves = 0;
    parm->gflip_max_iterations = 1000;
    parm->simba_T = 0;
    parm->isimba_T = 0;
    parm->mabuse_max_instances = 0;
    parm->mabuse_feat_per_iteration = 0;
    parm->sample_using_kmeans_subset_size = 0;
    parm->mabuse_max_losing_streak = 0;
    parm->mabuse_feature_life = 1;
    parm->mabuse_folds = 1;
    parm->rf_ntree = 100;
    parm->elm_n_hidden = 10;
    parm->cv_sampling_size = 0;
    parm->training_max_size = 0;
    parm->dt_min_samples_split = 10;
    parm->dt_max_depth = 0;
    parm->ml_min_k = 10;
    parm->ml_max_k = 10;
    parm->bbis_instances_per_iteration = 0;
    parm->mlknn_k_per_label_stepwise_attempts = 1;
    parm->mlksnn_min_k = 1;
    parm->mlksnn_max_k = 100;
    parm->bkmeans_iter = 1000;

    // Scalar values
    parm->cc_memetic_mutation_for_subpop = 0.0;
    parm->cc_memetic_mutation_for_subpop_bit_ratio = 0.0;
    parm->a = 1.0;
    parm->addF_mutation = 0.0;
    parm->addI_mutation = 0.0;
    parm->addiorf_mutation = 0.0;
    parm->alpha = 0.1;
    parm->alpha0 = 1.0;
    parm->alpha_acc = 0.5;
    parm->alpha_max = 1.0;
    parm->alpha_ok = 1.0;
    parm->alpha_red = 1.0;
    parm->alpha_redfeat = 0.0;
    parm->alpha_redins = 0.0;
    parm->angle_step = 1.0;
    parm->a_output = 1.0;
    parm->asymmetric_adaboost_k = 0;
    parm->asymptote = 0.2;
    parm->b = 0.6666;
    parm->bit_mutation = 0.1;
    parm->bit_mutation = 0.2;
    parm->boost_based_is_mutation = 0.0;
    parm->boostfs_w_acc = 1.0;
    parm->boostfs_w_auprc = 1.0;
    parm->boostfs_w_auroc = 1.0;
    parm->boostfs_w_gme = 1.0;
    parm->boostfs_w_kap = 1.0;
    parm->subpop_drop3_mut = 0.0;
    parm->subpop_oss_mut = 0.0;
    parm->boostfs_w_red = 1.0;
    parm->boostrsm_acc = 0.5;
    parm->boostrsm_dim = 0.25;
    parm->boostrsm_overlap = 0.25;
    parm->b_output = 1.0;
    parm->chc_init_prob = 0.1;
    parm->chc_subpop_init_prob = 0.25;
    parm->cc_memetic_mutation = 0.0;
    parm->C_minus = 1.0;
    parm->C_plus = 1.0;
    parm->cub_lambda = 3.0;
    parm->cv_val_percent = 0.1;
    parm->de_cr = 0.0;
    parm->de_f = 0.0;
    parm->de_local_search_is_probability = 0.0;
    parm->de_local_search_k_probability = 0.0;
    parm->delta0 = 0.02;
    parm->delta_max = 50.0;
    parm->delta_min = 0.000001;
    parm->lr_alpha = 0.1;
    parm->de_np = 0.0;
    parm->de_undersample_mut_prob = 0.0;
    parm->diff_w = 0.0;
    parm->dimension_scale = 1.0;
    parm->drop3_mutation = 0.0;
    parm->eb_accuracy_w = 0.0;
    parm->eb_average_precision_w = 0.0;
    parm->eb_coverage_w = 0.0;
    parm->eb_f1_w = 0.0;
    parm->eb_hamming_loss_w = 0.0;
    parm->eb_one_error_w = 0.0;
    parm->eb_precision_w = 0.0;
    parm->eb_ranking_loss_w = 0.0;
    parm->eb_recall_w = 0.0;
    parm->eb_subset_accuracy_w = 0.0;
    parm->eda_sigma = 1.0;
    parm->elite = 0.1;
    parm->eta0 = 0.65;
    parm->eta = 0.35;
    parm->eta_max = 2.0;
    parm->eta_minus = 0.5;
    parm->kperlabel_local_opt_ratio = 0.0;
    parm->eta_plus = 1.2;
    parm->fast_theta = -1.0;
    parm->fb_delta = 0.0;
    parm->fb_epsilon = 0.0;
    parm->fcbf_delta = -1.0;
    parm->fitness_w = 0.5;
    parm->flat_spot = 0.1;
    parm->focus_mutation = 0.0;
    parm->reduction_perlabel_w = 0.0;
    parm->fred_w = 0.0;
    parm->fs_threshold_step = 1.0;
    parm->ga_alpha = 0.75;
    parm->gamma = 1.0;
    parm->ml_k_penalty_from_cv = 0.0;
    parm->gamma_alpha = 0.05;
    parm->eps_t = 0.5;
    parm->gamma_eta = 0.1;
    parm->gga_crossover_prob = 0.6;
    parm->gga_elitism = 0.1;
    parm->gga_mutation = 0.0;
    parm->hda_lambda = 0.2;
    parm->hda_nu = 0.01;
    parm->hmnei_epsilon = 0.1;
    parm->ib3_mutation = 0.0;
    parm->icf_mutation = 0.0;
    parm->imoea_mutation = 0.0;
    parm->init_fs_percent = 0.25;
    parm->init_percent = 0.25;
    parm->init_setprob = 0.25;
    parm->evosmote_noise_mutation_rate = 0.0;
    parm->init_weight = 0.5;
    parm->instance_weight_limit = 0.0;
    parm->ired_w = 0.0;
    parm->isfs_cache_size = 1.0;
    parm->is_threshold_step = 1.0;
    parm->kappa_alpha = 0.5;
    parm->kappa_eta = 0.095;
    parm->kscbf_alpha = 0.05;
    parm->lambda = 0.0;
    parm->lb_accuracy_macro_w = 0.0;
    parm->lb_accuracy_micro_w = 0.0;
    parm->eb_auc_w = 0.0;
    parm->lb_auc_macro_w = 0.0;
    parm->lb_auc_micro_w = 0.0;
    parm->eb_f1_alt_w = 0.0;
    parm->lb_f1_macro_w = 0.0;
    parm->mlrs_beta = 0.9;
    parm->lb_f1_micro_w = 0.0;
    parm->lb_precision_macro_w = 0.0;
    parm->auroc_w = 0.0;
    parm->lb_precision_micro_w = 0.0;
    parm->lb_recall_macro_w = 0.0;
    parm->lb_recall_micro_w = 0.0;
    parm->lfb_p = 0.75;
    parm->lle_alpha = 1.0;
    parm->lle_max_dimension = 1.0;
    parm->lle_min_dimension = 1.0;
    parm->localk_alpha_acc = 0.5;
    parm->localk_alpha_mar = 0.05;
    parm->localk_alpha_reg = 0.05;
    parm->localk_holdout_percent = 0.1;
    parm->localk_memetic_bit_mutation_ratio = 0.25;
    parm->localk_memetic_mutation_ratio = 0.1;
    parm->bpmll_alpha = 0.05;
    parm->kperlabel_different_ks_penalty = 0.0;
    parm->mrknn_f = 2.0;
    parm->pptc_t = 0.2;
    parm->localk_mutation = 0.0;
    parm->localk_mutation_with_no_selection = 0.0;
    parm->local_perf_w = 0.5;
    parm->ml_elitism = 0.0;
    parm->negatives_ml_w = 0.0;
    parm->ls_factor_old_individuals = 0.0;
    parm->majority_fs_ratio = 0.0;
    parm->majority_is_ratio = 0.0;
    parm->max_adjacency_matrix_size = 1.0;
    parm->maximum_to_train = 1.0;
    parm->max_ratio = 1.0;
    parm->minimum_to_train = 0.1;
    parm->ml_multiselection_mutation_ratio = 0.0;
    parm->minority_fs_ratio = 0.0;
    parm->mlrf_t = 0.5;
    parm->minority_is_ratio = 0.0;
    parm->mlrs_s = 1.0;
    parm->min_ratio = 0.0;
    parm->min_votes = 0;
    parm->mlknn_s = 1.0;
    parm->mss_mutation = 0.0;
    parm->mutation = 0.01;
    parm->mutation_prob = 0.1;
    parm->ml_ensemble_t = 0.5;
    parm->nlp_bias_input = 1.0;
    parm->chc_random_evaluation_ratio = 1.0;
    parm->nlp_lambda = 0.0001;
    parm->ok_w = 0.5;
    parm->one_probability = 0.5;
    parm->percent_error_estimation = 1.0;
    parm->percent_for_early_stopping = 0.1;
    parm->performance_w = 0.5;
    parm->phi_alpha = 0.1;
    parm->phi_eta = 0.1;
    parm->npv_w = 0.0;
    parm->presample_ratio = 0.0;
    parm->projection_a = 1.0;
    parm->projection_alpha_hidden = 0.1;
    parm->projection_a_output = 1.0;
    parm->chc_pop_init_prob = 0.5;
    parm->projection_asymptote = 0.2;
    parm->ml_rus_p = 0.1;
    parm->bpmll_nodes = 1.0;
    parm->projection_b = 1.0;
    parm->optiondt_epsilon = 0.1;
    parm->projection_b_output = 1.0;
    parm->ml_chc_random_mut = 0.0;
    parm->projection_eta_hidden = 0.35;
    parm->n_predicted_ml_w = 0.0;
    parm->mltree_lambda = 0.9;
    parm->is_mutation = 0.0;
    parm->projection_limit_weight = 0.0;
    parm->random_addition_percent = 0.0;
    parm->random_sampling_for_threshold_evaluation_ratio = 0.1;
    parm->random_sampling_ratio = 0.1;
    parm->randomsel_ratio = 0.25;
    parm->random_undersampling_ratio = 1.0;
    parm->ml_k_memetic_mutation_ratio = 0.0;
    parm->ratio = 0.0;
    parm->reduction_ml_w = 0.0;
    parm->reduction_ml_ms_w = 0.0;
    parm->reduction_w = 0.0;
    parm->balance_w = 0.0;
    parm->relief_alpha = 0.0;
    parm->relieff_threshold = 0.0;
    parm->relief_threshold = 0.05;
    parm->rfe_mutation = 0.0;
    parm->rho = 0.0;
    parm->rnn_fs_mutation = 0.0;
    parm->rnn_isfs_mutation = 0.0;
    parm->tsa_t = 0.5;
    parm->rnn_is_mutation = 0.0;
    parm->rnn_mutation = 0.01;
    parm->rnnstd_mutation = 0.0;
    parm->rotation_class_selec_prob = 0.5;
    parm->oversampling_ratio = 1.0;
    parm->rsm_setprob = 0.5;
    parm->sampling_ratio = 0.1;
    parm->scale_max = 1.0;
    parm->rf_percent = 0.5;
    parm->scale_min = -1.0;
    parm->scca_precision = 0.00001;
    parm->selection_probability = 0.1;
    parm->sigma = 0.707106781;
    parm->ssga_mutation = 0.01;
    parm->subpop_difference_w = 0.0;
    parm->subpop_fitness_w = 0.0;
    parm->subpop_isolated_w = 0.0;
    parm->mlksnn_memetic_mut = 0.0;
    parm->mlksnn_ls_mut = 0.0;
    parm->subpop_mutation = 0.0;
    parm->subpop_onelabel_w = 0.0;
    parm->subpop_reduction_w = 0.0;
    parm->subpop_red_w = 0.5;
    parm->subpop_substitution_w = 0.0;
    parm->subsampling_ratio = 0.1;
    parm->sbc_nc = 2.0;
    parm->subspace_prob = 1.0;
    parm->subs_w = 0.0;
    parm->svm_c = 1.0;
    parm->svm_r = 0.0;
    parm->svm_r = 1.0;
    parm->theta = 0.7;
    parm->threshold = 0.0;
    parm->tolerance = 0.001;
    parm->ufs_epsilon = 0.1;
    parm->ufs_R2max = 0.5;
    parm->validation_percentage = 0.1;
    parm->val_percent = 0.25;
    parm->val_percentage = 0.1;
    parm->wmi_epsilon = -0.1;
    parm->isimba_lambda = 0.1;
    parm->isimba_delta = 0.1;
    parm->mabuse_filter_weighted_sampling_ratio = 1.0;
    parm->mabuse_ranking_initial_selection_percentage = 0.0;
    parm->mabuse_min_selected_percent = 0.0;
    parm->rank_w = 0.0;
    parm->quorum_sensing_threshold_max = 1.0;
    parm->quorum_sensing_threshold_min = 0.0;
    parm->precision_for_zero = 0.00001;
    parm->partial_selection_mutation = 0.0;
    parm->partial_selection_mutation_bit_ratio = 0.0;
    parm->partial_is_mutation = 0.0;
#ifdef ITERATIVE_SAMPLING_FOR_MLKsNN
    parm->kperlabel_sampling_ratio_step = 1.0;
#endif
    parm->accuracy_w = 0.0;
    parm->kappa_w = 0.0;
    parm->recall_macro_w = 0.0;
    parm->recall_macro_g_mean_w = 0.0;
    parm->average_accuracy_w = 0.0;
    parm->f1_w = 0.0;
    parm->cc_w = 0.0;
    parm->recall_w = 0.0;
    parm->specificity_w = 0.0;

    // Boolean values
    parm->partial_ci_samples = false;
    parm->adaptive_distance_measure = false;
    parm->adapt_ratio = true;
    parm->alpha_boost_set_to_one = false;
    parm->bagging_projection = true;
    parm->mabuse_roulette_selection = false;
    parm->balance_laststep = false;
    parm->bias = false;
    parm->boost_ci_initialization = false;
    parm->sifs2_convergence_with_only_acc = false;
    parm->boostis_considerlist = false;
    parm->boost_is = false;
    parm->br_adaboost_resampling = false;
    parm->ci = false;
    parm->class_perf_as_percentage = false;
    parm->cnn_ci = false;
    parm->coeff_as_geom_mean = false;
    parm->coeff_as_harm_mean = false;
    parm->comp_clas = false;
    parm->comp_votes = false;
    parm->cross_validate_dimension = false;
    parm->cv_hyperparameters = false;
    parm->cv_hyperparameters_for_testing = false;
    parm->cv_external_hyperparameters_for_testing = false;
    parm->cv_parameters = false;
    parm->cv_with_string_kernel = false;
    parm->decouple = false;
    parm->de_evolve_threshold = false;
    // parm->democratic_approach = false;
    parm->democratic_evaluation_of_threshold = true;
    parm->democratic_evaluation_of_threshold_with_cv = true;
    parm->demo_eval_exp_redfeature = true;
    parm->demo_eval_exp_redinstance = false;
    parm->de_separate_thresholds = false;
    parm->duplicate_features = false;
    parm->duplicate_instances = false;
    parm->duplicate_instances_with_noise = false;
    parm->dynamic_threshold = true;
    parm->early_stopping = false;
    parm->ebus_gs_gm = false;
    parm->cv_ml_hyperparameters = false;
    parm->sifs2_random_is_alg = false;
    parm->eda_use_only_missclass = false;
    parm->eda_wrapper = false;
    parm->edited_knn = true;
    parm->eval_exp_redfeature = false;
    parm->mleso_loo = true;
    parm->sifs2_stratified_incremental_selection = false;
    parm->eval_exp_redinstance = false;
    parm->multiselection_as_local_k = false;
    parm->evaluate_oligois_votes_with_auc = false;
    parm->evaluate_standard_knn = false;
    parm->sifs2_when_stratified_evaluate_with_training_set = false;
    parm->evaluate_train_error = false;
    parm->evaluate_undersampling = false;
    parm->ml_init_with_undersampling = false;
    parm->ml_use_hux = true;
    parm->ml_init_with_roulette = false;
    parm->evaluate_with[C45] = false;
    parm->evaluate_with[kNN] = false;
    parm->evaluate_with[MLP] = false;
    parm->symmetric_selection = false;
    parm->evaluate_with[NBC] = false;
    parm->evaluate_with[SVM] = false;
    parm->evaluate_with[ELM] = false;
    parm->evaluate_with_loo = true;
    parm->evaluate_with_external[XGBoost] = false;
    parm->evaluate_with_external[DeepLearning] = false;
    parm->evaluate_with_external[DecisionTree] = false;
    parm->evaluate_with_external[RandomForest] = false;
    parm->evaluate_with_external[NaiveBayes] = false;
    parm->ecc_with_bagging = true;
    parm->cheat_neg_to_pos_only = false;
    parm->use_mlcut = false;
    parm->evolutionary_local_k_and_is = false;
    parm->evolutionary_local_k = false;
    parm->evolve_k = false;
    parm->evolve_subspace = false;
    parm->exp_redfeature = false;
    parm->ibt_no_stop = false;
    parm->exp_redinstance = false;
    parm->exp_reduction = false;
    parm->external_partitioning_approach = false;
    parm->dt_grow_full_tree = false;
    parm->external_stratified_approach = true;
    parm->fasta_file = false;
    parm->three_way_is = false;
    parm->feature_partition = false;
    parm->feature_selection = false;
    parm->mlksnn_per_label_sampling = false;
    parm->feature_selection = true;
    parm->filter_noise = true;
    parm->ibt_fixed_node_weight = false;
    parm->ibt_predict_with_probabilities = false;
    parm->fixed_number_of_thresholds = false;
    parm->mleso_one_w = false;
    parm->force_balanced = false;
    parm->ml_ensemble_threshold_by_resubs = false;
    parm->feature_ranking = false;
    parm->force_undersampled = false;
    parm->fusion_from_first = false;
    parm->ml_cc_subpop_random_fitness = false;
    parm->fusion_subsets = false;
    parm->evosmote_only_minority = false;
    parm->get_best_round = false;
    parm->mlksnn_loo = true;
    parm->get_threshold_with_all = true;
    parm->grnn_cluster = false;
    parm->huge_dataset = false;
    parm->ind_filter = true;
    parm->ml_cc_random_order = false;
    parm->initially_marked = true;
    parm->lamlksnn_is = false;
    parm->pptc_no_loss = true;
    parm->ml_undersample_binary_learners = false;
    parm->ml_evolve_undersampled_subpops = false;
    parm->mldt_adaptive_threshold = false;
    parm->instance_partition = false;
    parm->instance_selection = true;
    parm->internal_partitioning_approach = false;
    parm->internal_stratified_approach = true;
    parm->isfs_inputs_first = true;
    parm->isfsmutation_random_order = false;
    parm->isfs_use_cache = true;
    parm->fs_use_cache = true;
    parm->isfs_use_fitness = true;
    parm->print_base_training_error = false;
    parm->is_use_cache = true;
    parm->fitness_as_ratio = false;
    parm->keep_class_distribution = false;
    parm->regularize_mlksnn = false;
    parm->knn_weight_by_distance = false;
    parm->isfs_stepwise_cache = false;
    parm->knn_with_weighted_votes = false;
    parm->laststep_ebus_gs_gm = false;
    parm->leave_no_neighbors_unchanged = false;
    parm->localk_no_neigbors_assign_nearest_value = false;
    parm->localk_populate = false;
    parm->cv_for_fitness_as_ratio = true;
    parm->ml_cc_weighted_qs = false;
    parm->localk_reevaluate = false;
    parm->LOO_for_knn_performance = true;
    parm->ls_only_use_selected = true;
    parm->mlksnn_update_ada_weight_with_current_best = false;
    parm->multiis_adjust_initial_percentage = true;
    parm->multiis_and_k_with_DE = false;
    parm->multiselection = false;
    parm->multiselect_only_minority_class = false;
    parm->nlp_project_from_previous = false;
    parm->noise_edition = true;
    parm->obtain_auc = true;
    parm->only_accept_if_better = true;
    parm->ml_is_set_k_cv = false;
    parm->pevus_remove_null = false;
    parm->pevus_random_init = false;
    parm->only_save_selection = false;
    parm->optimal_local_k = false;
    parm->output_2class_measures = true;
    parm->oversampling= false;
    parm->ml_ins_sel_per_label = false;
    parm->perform_last_iteration = false;
    parm->initialize_all_minority_class = false;
    parm->perform_laststep_is = false;
    parm->populate = false;
    parm->evosmote_roulette_initialization = false;
    parm->post_validate_k = false;
    parm->omp_allow_nested_loops = false;
    parm->presample = false;
    parm->presample_stratified = false;
    parm->pre_undersampling = false;
    parm->evosmote_one_w = false;
    parm->print_verbose = false;
    parm->projection_bias = false;
    parm->projection_disjoint_subspaces = false;
    parm->mabuse_use_rankings_for_perf = false;
    parm->projection = false;
    parm->mlksnn_ties_closer_to_cv_k = true;
    parm->prune_tree = false;
    parm->random_fs_algorithm = false;
    parm->ml_allow_negative_subpops = false;
    parm->mlrf_real_votes = false;
    parm->random_fs_algorithm_fast = false;
    parm->random_fs_algorithm_low_redundancy = false;
    parm->random_is_algo = false;
    parm->random_isalgorithm = false;
    parm->randomize_inputs_for_fs = false;
    parm->use_ranger_for_rf = false;
    parm->mlksnn_use_window = false;
    parm->prus_relative_ratio = false;
    parm->pros_relative_ratio = false;
    parm->random_sampling = false;
    parm->combine_metrics_gmean = false;
    parm->random_sampling_for_threshold_evaluation = false;
    parm->randomsel_withreplacement = false;
    parm->random_undersampling = false;
    parm->with_replacement = true;
    parm->random_undersampling_for_training = false;
    parm->rcga_random_projection = false;
    parm->rcga_undersample = false;
    parm->mleso_unsel_nocopy = false;
    parm->mleso_donot_eval_copies = true;
    parm->rcga_use_accuracy = false;
    parm->rcga_use_auc_measure = false;
    parm->reevaluate_individuals = false;
    parm->reinit_distance0 = true;
    parm->remove_constant_features = false;
    parm->ml_onesubpop_per_cycle = false;
    parm->remove_features_after_selection = false;
    parm->resample = true;
    parm->sifs2_is_additive = false;
    parm->ml_ins_sel_per_label_same_neighbors = false;
    parm->rprop_undo = false;
    parm->sampling = false;
    parm->save_graph = false;
    parm->save_kappa_error_data = false;
    parm->save_margins = false;
    parm->ml_return_best_performing = false;
    parm->save_outputs = false;
    parm->save_performance = false;
    parm->ml_init_with_cardinality = false;
    parm->save_projs = false;
    parm->save_selection = false;
    parm->scale_projection = true;
    parm->scca_already_projected = false;
    parm->select_fs_randomly = false;
    parm->selection_minority= true;
    parm->select_with_sorted_graph = false;
    parm->separate_inputs = false;
    parm->show_average_nn_margin = false;
    parm->soften_thresholds = false;
    parm->sparse_data = false;
    parm->sparse_format = false;
    parm->force_sparse_format = false;
    parm->stratified = false;
    parm->subsampling_for_evaluation = false;
    parm->symmetric_knn = false;
    parm->typify = true;
    parm->undersample_laststep = false;
    parm->print_dt = false;
    parm->bbis_select_best_instance_from_every_class = true;
    parm->ml_cc_mutate_elite = false;
    parm->ml_cc_combine_best_subinviduals = false;
    parm->ml_cc_local_opt_best = false;
    parm->sifs2_best_with_only_acc = false;
    parm->undersampling = false;
    parm->use_all_data = true;
    parm->use_averaged_accuracy_for_stop = false;
    parm->use_brent = false;
    parm->use_edge_list_for_graph = false;
    parm->use_g_mean = false;
    parm->use_g_measure = false;
    parm->use_grnn = false;
    parm->use_neighbors_cache = true;
    parm->use_pcomponents = false;
    parm->use_validation_data_for_votes_threshold = false;
    parm->validate_k = false;
    parm->validation_until_end = true;
    parm->weight_votes = false;
    parm->ml_relative_multiselection = false;
    parm->weigthed_sampling_for_training = false;
    parm->evaluate_margin = false;
    parm->sample_using_kmeans = false;
    parm->cv_k_for_testing = false;
    parm->mabuse_condit_excl_with_margin = false;
    parm->time_all = false;
    parm->minimum_info = false;
    parm->keep_files = false;
    parm->evaluate_ml_with[MLkNN] = false;
    parm->ml_use_hash_table = true;
    parm->ml_select_subpop_by_relevance = false;
    parm->ml_return_overall_best = false;

    // Enumerated values
    parm->base_learner = C45;
    parm->binary_classifier = C45;
    parm->subpop_binary_classifier = kNN;
    parm->br_model = SVM;
    parm->ps_model = SVM;
    parm->cc_model = SVM;
    parm->dbr_model = SVM;
    parm->sta_model = SVM;
    parm->boostfs_classifier = C45;
    parm->boosting_resampling_method = WithoutReplacement;
    parm->boostis_classifier = kNN;
    parm->boostisfs_classifier = kNN;
    parm->chc_wrapper = kNN;
    parm->sifs2_evaluator = kNN;
    parm->classifier = C45;
    parm->class_weight_method = TrainingStratum;
    parm->class_weight = StdAda;
    parm->combination = Voting;
    parm->data_partition_method = RandomDataPartition;
    parm->discretizer = dFAYYAD;
    parm->ensemble_implementation = Resampling;
    parm->ensemble_method = AdaBoost;
    parm->ensemble_technique = Resampling;
    parm->evaluator = ekNN;
    parm->evolutionary_scheme = schemeCHCGA;
    parm->external_partitioning_method = pRANDOM;
    parm->fralgorithm = frCUB;
    parm->fsalgorithm = fsFCBF;
    parm->feature_subset_evaluation = ClassModel;
    parm->imbalance_method = iNone;
    parm->internal_partitioning_method = pRANDOM;
    parm->isalgorithm = CHC;
    parm->isalgorithm = DROP3;
    parm->laststep_isalgorithm = ICF;
    parm->isfsalgorithm = CHCGA;
    parm->localk_error_estimation_method = kFOLDCV;
    parm->margin_method = NormalizedVotesDifference;
    parm->merge_method = Or;
    parm->ml_instance_selection = NoInstanceSelection;
    parm->ml_feature_selection = NoFeatureSelection;
    parm->ml_method = MLkNN;
    parm->nlp_previous = Classifier;
    parm->oligo_threshold_evaluation = BothSimultenously;
    parm->partition = pRANDOM;
    parm->votes_threshold_measure = pfKappa;
    parm->performance_measure = pfKappa;
    parm->mabuse_performance_measure = pfKappa;
    parm->projection_algorithm = RProp;
    parm->projection_regularization = Kuo;
    parm->projection_transfer_h = HypTan;
    parm->elm_tf = HypTan;
    parm->projection_transfer = HypTan;
    parm->projection_transfer_o = Log;
    parm->rnge_pg = Gabriel;
    parm->rnge_pg= RelativeNeighborhood;
    parm->scale_inputs = Scale;
    parm->search_heuristic = SFS;
    parm->subspace_method = AllInputs;
    parm->ps_strategy = A;
    parm->rank_to_fs_threshold_evaluation = Voor;
    parm->transfer_h = HypTan;
    parm->transfer_o = Log;
    parm-> undersampling_method = umRandom;
    parm->votes_evaluator_classifier = kNN;
    parm->votes_evaluator = kNN;
    parm->votes_recording_method = ICPOS;
    parm->boostfs_classifier = C45;
    parm->wrapper_fs_classifier = C45;
    parm->mabuse_ensemble_method = AdaBoost;
    parm->boostedis_ensemble_method = AdaBoost;
    parm->NBC_discretizer = FANDI;
    parm->cv_sampling_method = sNone;
    parm->mrmr_evaluator = kNN;
    parm->mrmr_search = SFS;
    parm->ibt_ens_method = NoBoost;
    parm->ibt_alpha_method = NoBoost;
    parm->base_learner = kNN;
    parm->subpop_perf_measure = pfGMean;
    parm->ml_kperlabel_method = Evolutionary;
    parm->ml_cc_pop_evol_scheme = schemeSSGA;
    parm->ml_ensemble_method = MLNone;
    parm->smote_variant = vSMOTE;
    parm->external_base = DecisionTree;
    parm->ibt_split_measure = imInformationGain;
    parm->rforest_split_measure = imInformationGain;
    parm->label_propagation = EVOL;

    // Others
    parm->time_limit = (time_t) 0;
    parm->c45_weights = NULL;
}
