/***************************************************************************
 *   Copyright (C) 2018 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <pvm3.h>
#include <unistd.h>
#include <string.h>
#include <stdbool.h>
#include "common.h"
#include "macros.h"

// Skynet nodes and number of cores for PVM scheduling
// Machines: 79 + Skynet
// Cores: 760

int main()
{
    char *machines[] = {"skynetx01", "skynetx02", "skynetx03", "skynetx04", "skynetx05", "skynetx06", "skynetx07", "skynetx08", "skynetx09", "skynetx10", "skynetx11",
                        "skynetx12", "skynetx13", "skynetx14", "skynetx15", "skynetx16",
                        "skynet401", "skynet402", "skynet403", "skynet404", "skynet405", "skynet406", "skynet407", "skynet408", "skynet409", "skynet410", "skynet411",
                        "skynet412", "skynet413", "skynet414", "skynet415", "skynet416",
                        "skynet501", "skynet502", "skynet503", "skynet504", "skynet505", "skynet506", "skynet507", "skynet508", "skynet509", "skynet510", "skynet511",
                        "skynet512", "skynet513", "skynet514", "skynet515", "skynet516",
                        "skynet101", "skynet102", "skynet103", "skynet104", "skynet105", "skynet106", "skynet107", "skynet108", "skynet109", "skynet110", "skynet111",
                        "skynet201", "skynet202", "skynet203", "skynet204", "skynet205", "skynet206",              "skynet208", "skynet209", "skynet210", "skynet211",
                        "skynet301", "skynet302", "skynet303", "skynet304", "skynet305",              "skynet307", "skynet308", "skynet309", "skynet310", "skynet311"
                       };

    int ok = 0, n_machines = 79;


    // Check status of all machines
    for (int i = 0; i < n_machines ; i++) {
        int status = pvm_mstat(machines[i]);

        switch (status) {
            case PvmOk:
                printf("%s status Ok\n", machines[i]);
                ok++;
                break;

            case PvmNoHost:
                printf("%s not in virtual machine\n", machines[i]);
                break;

            case PvmHostFail:
                printf("%s unreachable\n", machines[i]);
                break;

            default:
                printf("Unknown status\n");
        }

    }

    return ok;
}
