/***************************************************************************
 *   Copyright (C) 2018 by Nicolas Garcia-Pedrajas        *
 *   npedrajas@uco.es   *
 *     *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version. *
 *     *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.         *
 *     *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the        *
 *   Free Software Foundation, Inc.,     *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "typex.h"

// External variables associated with global types

char *isalgorithm[] = {"NoIS", "DROP2", "DROP3", "ICF", "CHC", "MSS", "RNN", "IB3", "RANDOM", "PSRCG", "RC45", "CFilter", "PSA", "CNN", "CNNTL", "OSS", "SMOTE", "Entropy", "Undersampling", "GCNN",
                       "BoostBased", "RMHC", "HMNEI", "RNGE", "LVQPRU", "SimulatedAnnealing", "kNNCHC", "MCS"},
        *fsalgorithm[] = {"NoFS", "GA", "LVF", "FOCUS", "RELIEFF", "RFE", "CLASSIFIER", "RANDOM", "ABB", "BB", "FCBF", "FOCUS-SF", "FAST", "CFS-SF", "SetCover", "QBB", "SFFS", "SBFS",
                           "MICIBM", "CHC", "RANKING", "UFS", "K-SCBF", "MABUSE", "GFlip", "BMIFS", "wMI", "iSimba", "mRMR"},
        *isfsalgorithm[] = {"NoISFS", "CHCGA", "IMOEA", "ISplusFS", "FSplusIS", "SIFS2", "RMHC-PF1"},
        *partitions[] = {"Random", "Board", "Equal", "RProtos", "OneInput", "GrandTour", "2DGrandTour","kMeans", "kClustering", "Decoupled", "eBagging"},
        *ensembles[] = {"NoBoost", "AdaBoost", "RealAdaBoost", "DiscreteAdaBoost", "Wagging", "Bagging", "RandomSubsampling", "GentleBoost", "MadaBoost", "ReweightBoost", "MultiBoost",
            "FloatBoost", "BalanceCascade", "EasyEnsemble", "AsymmetricAdaBoost", "AdaCost", "AdaC1", "AdaC2", "AdaC3", "CSB0", "CSB1", "CSB2", "Arcing", "BoostingProj", "RandomProj",  "AdaBoostMH",
            "FeatureBoost", "FreundNN", "RotationForest", "LearningFromBites", "FilterBoost"},
        *performance[] = {"Accuracy", "GMean", "Kappa", "auROC", "auPRC", "RecallMacro", "RecallMacroGMean", "Margin", "AverageAccuracy", "PrecisionMacro", "F1Macro", "CC", "F1"},
        *fralgorithm[] = {"CUB", "Fisher", "InformationGain", "RFE", "MutualInformation", "ChiSquare", "ShannonEntropy", "DifferentialShannonEntropy", "ReliefF", "SVDEi", "EDSE", "GainRatio",
                          "F-Score", "t-Test", "Wilcoxon", "SOMIFS", "Simba", "iSimba"},
        *votes_recording[] = {"ICPOS", "ICPOSNEG", "CCMAJ", "CCONCE"},
        *evolutionary_scheme[] = {"CHCGA", "SSGA", "SSMA", "GGA"},
        *proximity[] = {"Gabriel", "RelativeNeighborhood"},
        *discretizer[] = {"FAYYAD", "WPKID", "NONE"},
        *search[] = {"SFS", "SBS", "LRS", "SFFS", "SFBS"},
        *estimation[] = {"Leave One Out", "k-FOLDCV", "Resubstitution", "Bootstrap", "E632", "Hold Out", "Artificial Data"},
        *margin_method[] = {"Votes difference", "Average neighborhood margin", "Normalized Votes Difference", "Smoothed Votes Difference", "Normalized Average Neighborhood Margin",
                            "Ordered Votes Difference", "Normalized", "Ordered Votes Difference", "Nearest Neighbor Enemy Distance"},
        *sampling[] = {"WithReplacement", "WithoutReplacement", "Subsample", "CISubsample"},
        *learner[N_CLASSIFIERS] = {"SVM", "k-NN", "C4.5", "ELM", "MLP", "NBC", "DT(Accuracy)", "IBT", "RF", "1-NN", "GaussianNBC", "DT(CART)", "DT(C4.5)", "DT(ID3)", "LR", "RForest", "ExtraTree",
                                    /* Non-base classifiers*/
                                   "OVO", "AdaBoost.M1", "MadaBoost", "MultiBoost", "Bagging", "GentleBoost", "ReweightBoost", "FloatBoost", "FeatureBoost", "Arcing"},
        *implementation[] = {"Resampling", "Reweighting", "ResamplingWithoutReplacement"},
        *feature_subset_evaluation[] = {"Classifier", "MFDR", "VOOR", "MFE", "CF", "LOOR", "RIIC"},
        *nbcinterval[] = {"EWD", "EFD", "PKID", "WPKID", "FANDI"},
        *samplingmethod[] = {"None", "KMeans", "Stratified"},
        *ml_instance_selection[N_ML_INSTANCE_SELECTION] = {"None", "CooperativeCoevolution", "CHCIS", "LAML-kNNIS", "DEIS"},
        *ml_feature_selection[N_ML_FEATURE_SELECTION] = {"None", "CHCFS"},
        *mlpartition[] = {"NoDataPartition", "RandomPartition", "Clustering"},
        *merge_method[] = {"And", "Or", "MajorityVoting", "QuorumSensing"},
        *split_measure[] = {"Accuracy", "Gini", "GainRatio", "InformationGain"},
        *class_imbalance_method[] = {"None", "Oversampling", "Undersampling", "SMOTE", "EvoSMOTE", "ROSE", "ADASYN", "BorderlineSMOTE", "KMeansSMOTE", "SVMSMOTE", "SMOTETomek", "SMOTEENN", "IHT",
                                     "NCR", "NearMiss", "SMOTEVariant"},
        *ml_class_imbalance_method[N_ML_CI_METHOD] = {"None", "RandomOS", "MLSmote", "ML-ESO", "RandomUS", "PRUS", "PROS", "PRUOS", "PROUS", "PEVUS", "RepopLabels"},
        *ml_kperlabel_method[] = {"Evolutionary", "SingleLabel", "GreedyPerLabel", "PerpendicularSearch", "DifferentialEvolution", "LAMLksNNEvolutionary"},

        /* Classifiers */
        // *classifier[N_CLASSIFIERS] = {"SVM", "k-NN", "C4.5", "ELM", "MLP", "NBC", "DT", "IBT", "OVO", "RF", "1-NN", "GaussianNBC"},
        *external[N_EXTERNAL] = {"Naive Bayes", "Decision Tree", "Random Forest", "XGBoost", "PLS-DA", "Deep Learning", "SVC", "LDA", "QDA", "GPML", "RidgeRegression", "Extremely Randomized Trees",
                                 "Kernel Ridge Regression", "AdaBoost.R", "AdaBoost.D"},
        *ml_method[N_ML_CLASSIFIERS] = {"ML-kNN", "BR", "CC", "LAML-kNN", "ML-ksNN", "LAML-ksNN", "RAkEL-O", "RAkEL-D", "LP", "CLR", "HOMER-B", "HOMER-K", "HOMER-R", "ML-DT", "ML-BASICBP", "BP-MLL",
                                        "ML-RF", "DBR", "STA", "NS", "ECC", "IBLR-ML", "IBLR-ML+", "PCT", "E-PCT", "RF-PCT", "TSVM", "TSCCM", "TSPCCM", "ML-TREE", "ML-FOREST", "MLRS", "MLRS-LC",
                                        "OPCT", "Stacked ML-kNN", "DML-kNN", "Mr.KNN", "MLC-DWkNN.D", "MLC-DWkNN.M", "MLC-DWkNN.Z", "FRONEC-1.H", "FRONEC-2.H", "FRONEC-3.H", "FRONEC-1.Ld",
                                        "FRONEC-2.Ld", "FRONEC-3.Ld", "FV-kNN", "NSSC", "E-DT", "Extra-PCT", "PRUNEDSETS", "EPS", "PPT", "PPT-n", "PPT-c", "Extra-MLDT", "ZERO",
                                        // Ensembles
                                        "Bagging", "RealAdaBoost.RE", "DiscreteAdaBoost.RE", "RealAdaBoost.MH", "DiscreteAdaBoost.MH"},
        *ml_ext_method[N_ML_EXT_CLASSIFIERS] = {"LabelPowerset", "ClassifierChain", "RAkELd", "RAkELo", "MLARAM", "BinaryRelevance", "ML-kNN-py", "BRkNNa", "BRkNNb", "MLTSVM", "MLMLP", "DL",
                                                "BOOMER", "BCC", "CDN", "HASEL", "PSt", "CT", "MCC", "NSR", "SCC", "PS", "LC", "CDT", "DBPNN", "FW", "Maniac", "PCC", "PMCC"},
        *ml_ext_base_method[N_ML_EXT_BASE_CLASSIFIERS] = {"LogisticRegression", "kNearestNeighbor", "RandomForest", "DecisionTree", "GaussianNB", "SVMLinear", "SVMGaussian", "AdaBoost",
                                                          "MLPerceptron"},
        *subset_evaluation[N_FEATURE_SUBSET_EVALUATION] = {"Performance", "Mfdr", "Voor", "Mfe", "Cf", "Loor", "Riic"},
        *subset_combination[N_FEATURE_SUBSET_COMBINATION] = {"Thresholding", "Union", "Intersection", "Majority"},
        *ml_ensemble_methods[] = {"None", "eBagging", "AdaBoostMH"},
        *ml_resampling[] = {"ResamplingPerLabel", "ResamplingPerInstance", "ResamplingPartial"},
        *smote_variant[] = {"SMOTE", "SMOTE_TomekLinks", "SMOTE_ENN", "Borderline_SMOTE1", "Borderline_SMOTE2", "ADASYN", "AHC", "LLE_SMOTE", "distance_SMOTE", "SMMO", "polynom_fit_SMOTE",
                            "Stefanowski", "ADOMS", "Safe_Level_SMOTE", "MSMOTE", "DE_oversampling", "SMOBD", "SUNDO", "MSYN", "SVM_balance", "TRIM_SMOTE", "SMOTE_RSB", "ProWSyn", "SL_graph_SMOTE",
                            "NRSBoundary_SMOTE", "LVQ_SMOTE", "SOI_CJ", "ROSE", "SMOTE_OUT", "SMOTE_Cosine", "Selected_SMOTE", "LN_SMOTE", "MWMOTE", "PDFOS", "IPADE_ID", "RWO_sampling", "NEATER",
                            "DEAGO", "Gazzah", "MCT", "ADG", "SMOTE_IPF", "KernelADASYN", "MOT2LD", "V_SYNTH", "OUPS", "SMOTE_D", "SMOTE_PSO", "CURE_SMOTE", "SOMO", "ISOMAP_Hybrid", "CE_SMOTE",
                            "Edge_Det_SMOTE", "CBSO", "E_SMOTE", "DBSMOTE", "ASMOBD", "Assembled_SMOTE", "SDSMOTE", "DSMOTE", "G_SMOTE", "NT_SMOTE", "Lee", "SPY", "SMOTE_PSOBAT", "MDO",
                            "Random_SMOTE", "ISMOTE", "VIS_RST", "GASMOTE", "A_SUWO", "SMOTE_FRST_2T", "AND_SMOTE", "NRAS", "AMSCO", "SSO", "NDO_sampling", "DSRBF", "Gaussian_SMOTE",
                            "kmeans_SMOTE", "Supervised_SMOTE", "SN_SMOTE", "CCR", "ANS", "cluster_SMOTE"},
        *ps_strategy[] = {"A", "B"},
        *label_propagation[] = {"Evolutionary", "And", "Or", "Copy", "Minority", "MinorityOr"};

int n_isalgorithm = 28, n_fsalgorithm = 29, n_isfsalgorithm = 7, n_partitions = 11, n_ensembles = 31, n_performance = 13, n_fralgorithm = 18, n_votes_recording = 4, n_ps_strategy = 2,
    n_class_imbalance_method = N_CLASS_IMBALANCE_METHODS, n_evolutionary_scheme = 4, n_proximity = 2, n_discretizer = 3, n_search = 5, n_estimation = 7, n_margin_method = 8, n_sampling = 4,
    n_classifier = N_CLASSIFIERS, n_implementation = 3, n_selection = 7, n_feature_subset_evaluation = 7, n_nbcinterval = 5, n_samplingmethod = 3, n_ml_instance_selection = N_ML_INSTANCE_SELECTION,
    n_mlpartition = 3, n_merge_method = 4, n_ml_ensemble_methods = 3, n_split_measure = 4, n_ml_kperlabel_method = 6, n_mlmethod = N_ML_CLASSIFIERS, n_ml_class_imbalance_method = N_ML_CI_METHOD,
    n_ml_ext_method = N_ML_EXT_CLASSIFIERS, n_ml_ext_base_method = N_ML_EXT_BASE_CLASSIFIERS, n_smote_variant = 85, n_subset_combination = N_FEATURE_SUBSET_COMBINATION, n_ml_resampling = 3,
    n_subset_evaluation = N_FEATURE_SUBSET_COMBINATION, n_ml_feature_selection = N_ML_FEATURE_SELECTION, n_base_classifier = N_BASE_CLASSIFIERS, n_ml_base_classifier = N_ML_BASE_CLASSIFIERS,
    n_label_propagation = N_LABEL_PROPAGATION;
