/***************************************************************************
 *   Copyright (C) 2019 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdbool.h>
#include "typex.h"
#include "macros.h"

// Write sparse data in libSVM format
// Class [0,C-1] index[1:F]:value

void SaveLibSVMData(scalar **data, int **index, int *labels, int instances, char *file)
{
    FILE *f;

    if ((f = fopen(file, "w")) == NULL)
        OnErrorExit(ERR_FILE, "Cannot open file for sparse data inm libSVM format");

    for (int i = 0; i < instances; i++) {
        fprintf(f, "%d", labels[i]);
        int n = 0;
        while (index[i][n] != -1) {
            fprintf(f, " %d:%g", index[i][n], data[i][n]);
            n++;
        }
        fprintf(f, "\n");
    }

    fclose(f);
}
