/***************************************************************************
 *   Copyright (C) 2023 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include "classifiers.h"
#include "macros.h"
#include "maths.h"
#include "ensemble.h"

// Test whether classifier is an ensemble or a single classifier

bool IsEnsemble(t_Classifier classifier)
{
    bool itis = false;

    switch (classifier) {
        case SVM:
        case kNN:
        case C45:
        case ELM:
        case MLP:
        case NBC:
        case DT_CA:
        case IBT:
        case RF:
        case NN:
        case GNBC:
        case DT_CART:
        case DT_C45:
        case DT_ID3:
        case LR:
        case RForest:
        case OVO:
        case ExtraTree:
            itis = false;
            break;

        case AdaBoostM1:
        case MadaBoost:
        case MultiBoost:
        case Bagging:
        case GentleBoost:
        case ReweightBoost:
        case FloatBoost:
        case FeatureBoost:
        case ARCING:
            itis = true;
            break;
    }

    return itis;
}
