/***************************************************************************
 *   Copyright (C) 2019 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
// Definitions and prototypes
#ifndef _EXTERNAL_H
#define _EXTERNAL_H

#include <stdbool.h>
#include <stdio.h>
#include <time.h>
#include "typex.h"
#include "common.h"

// Prototypes
/* RandomForest.c */
void GetRandomForestConfusionMatrix(const t_Parameters *, scalar **, int, int *, int *, int *, int, int, scalar **, int, int *, int **, int **, int **, char *, scalar *, scalar *, scalar *);
/* external.c */
void GetExternalClassifierConfusionMatrix(const t_Parameters *, t_ExternalClassifier, scalar **, int, int *, int *, int *, int, int, scalar **, int, int *, int **, int **, int **, char *, scalar *,
                                          scalar *, scalar *, int, scalar *, scalar *);
/* python.c */
void GetConfusionMatrixWithPython(const t_Parameters *, scalar **, int, int *, int *, int *, int, int, scalar **, int, int *, int **, int **, int **, char *, scalar *, scalar *, scalar *,
                                  t_ExternalClassifier, int, scalar *, scalar *);
void SaveLIBsvmFormat(scalar **, int, int, int *, int *, int *, char *);
void SaveCSVFormat(scalar **, int, int, int *, int *, int *, char *);

#endif                          /* !_EXTERNAL_H */
