
/***************************************************************************
 *   Copyright (C) 2015 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <typex.h>
#include "fs.h"
#include "defns.i"
#include "types.i"
#include "extern.i"
#include "macros.h"
#include "common.h"
#include "svm.h"
#include "is.h"
#include "data.h"

// Remove instances correctly classified from the majority class

int BalanceCascadeRemoveInstances(const t_Parameters *parm, int **subspaces, scalar **data, int instances, int *labels, int inputs, int size, int iteration, bool cv, int *list, int *list_size,
                                  scalar **train_data, int *train_labels, scalar *alpha, scalar *w)
{
    OnErrorExit(ERR_NOT_YET_IMPLEMENTED, "Needs updating");

    //     struct svm_model *svms[size];
    //     Tree trees[size];
    //     int removed = 0, minority;
    //
    //     minority = (train_labels[list[0]]+1)%2;
    //
    //     // Train classifiers if not k-NN
    //     if (parm->boostfs_classifier == C45) {
    //         for (int i = 0; i < size; i++) {
    //             if (parm->weigthed_sampling_for_training) {
    //                 scalar *cumulative_probabilities, **s_data;
    //                 int *s_labels;
    //
    //                 MALLOC(cumulative_probabilities, scalar, instances, "BalanceCascadeRemoveInstances: cumulative_probabilities");
    //                 MALLOC(s_data, scalar *, instances, "BalanceCascadeRemoveInstances: s_data");
    //                 MALLOC(s_labels, int, instances, "BalanceCascadeRemoveInstances: s_labels");
    //
    //                 cumulative_probabilities[0] = w[0];
    //                 for (int k = 1; k < instances; k++)
    //                     cumulative_probabilities[k] = cumulative_probabilities[k-1] + w[k];
    //                 for (int k = 0; k < instances; k++) {
    //                     int instance = RouletteSelection(cumulative_probabilities, instances);
    //
    //                     s_labels[k] = labels[instance];
    //                     s_data[k] = data[instance];
    //                 }
    //
    //                 if (cv)
    //                     SetCrossValidatedParametersSubspace((t_Parameters *) parm, s_data, instances, s_labels, subspaces[iteration-size+1+i], inputs, 2, C45, minority);
    //
    //                 trees[i] = TrainC45ClassifierSubspace(parm, s_data, subspaces[iteration-size+1+i], instances, s_labels, inputs, true);
    //
    //                 FREE(s_data);
    //                 FREE(cumulative_probabilities);
    //                 FREE(s_labels);
    //             } else if (parm->random_undersampling_for_training) {
    //                 scalar **u_data = NULL;
    //                 int u_instances = 0, *u_labels = NULL;
    //                 TemporalUndersampleDataForTraining(data, instances, 2, labels, parm->random_undersampling_ratio, &u_data, &u_labels, &u_instances, minority);
    //
    //                 if (cv)
    //                     SetCrossValidatedParametersSubspace((t_Parameters *) parm, u_data, u_instances, u_labels, subspaces[iteration-size+1+i], inputs, 2, C45, minority);
    //
    //                 trees[i] = TrainC45ClassifierSubspace(parm, u_data, subspaces[iteration-size+1+i], u_instances, u_labels, inputs, true);
    //                 FREE(u_data);
    //                 FREE(u_labels);
    //             } else {
    //                 if (cv)
    //                     SetCrossValidatedParametersSubspace((t_Parameters *) parm, data, instances, labels, subspaces[iteration-size+1+i], inputs, 2, C45, minority);
    //
    //                 trees[i] = TrainC45ClassifierSubspace(parm, data, subspaces[iteration-size+1+i], instances, labels, inputs, true);
    //             }
    //         }
    //     } else if (parm->boostfs_classifier == SVM) {
    //         for (int i = 0; i < size; i++) {
    //             if (parm->weigthed_sampling_for_training)
    //                 OnErrorExit(ERR_NOT_YET_IMPLEMENTED, "Weighted undersampling for SVM method");
    //             else if (parm->random_undersampling_for_training) {
    //                 scalar **u_data = NULL;
    //                 int u_instances = 0, *u_labels = NULL;
    //                 TemporalUndersampleDataForTraining(data, instances, 2, labels, parm->random_undersampling_ratio, &u_data, &u_labels, &u_instances, minority);
    //
    //                 if (cv)
    //                     SetCrossValidatedParametersSubspace((t_Parameters *) parm, u_data, u_instances, u_labels, subspaces[iteration-size+1+i], inputs, 2, SVM, minority);
    //
    //                 svms[i] = TrainSVMClassifierSubspace(parm, u_data, subspaces[iteration-size+1+i], u_instances, u_labels, inputs);
    //                 FREE(u_data);
    //                 FREE(u_labels);
    //             } else {
    //                 if (cv)
    //                     SetCrossValidatedParametersSubspace((t_Parameters *) parm, data, instances, labels, subspaces[iteration-size+1+i], inputs, 2, SVM, minority);
    //                 svms[i] = TrainSVMClassifierSubspace(parm, data, subspaces[iteration-size+1+i], instances, labels, inputs);
    //             }
    //         }
    //     }
    //
    //     scalar **u_data = NULL;
    //     int u_instances, *u_labels = NULL;
    //     if (parm->random_undersampling_for_training && parm->boostfs_classifier == kNN)
    //         TemporalUndersampleDataForTraining(data, instances, 2, labels, parm->random_undersampling_ratio, &u_data, &u_labels, &u_instances, minority);
    //     else {
    //         u_data = data;
    //         u_instances = instances;
    //         u_labels = labels;
    //     }
    //
    //     // Test instances from majority class
    //     for (int i = 0; i < *list_size; i++)
    //         if (GetEnsembleCategory(parm->boostfs_classifier, u_data, train_data[list[i]], u_labels, u_instances, subspaces, parm->k, 2, inputs, svms, trees, size, iteration-size+1, parm->sampling_size,
    //                                 alpha) == train_labels[list[i]] && *list_size > 1) {
    //             // Remove correctly classified instances
    //             list[i] = list[*list_size-1];
    //             (*list_size)--;
    //             removed++;
    //             i--;
    //         }
    //
    //     if (parm->random_undersampling_for_training && parm->boostfs_classifier == kNN) {
    //         FREE(u_data);
    //         FREE(u_labels);
    //     }
    //
    //     // Free classifiers
    //     if (parm->boostfs_classifier == C45)
    //         for (int i = 0; i < size; i++)
    //             ReleaseTree(trees[i]);
    //     else if (parm->boostfs_classifier == SVM)
    //         for (int i = 0; i < size; i++)
    //             svm_free_and_destroy_model(&svms[i]);
    //
    //     return removed;

    return 0;
}

int GetEnsembleCategory(t_Classifier classifier, scalar **data, scalar *pattern, int *labels, int instances, int **subspaces, int k, int classes, int inputs, struct svm_model **svms, Tree *trees,
                        int size, int first, int sampling_size, scalar *alpha)
{
    OnErrorExit(ERR_NOT_YET_IMPLEMENTED, "Needs updating");
    //     scalar votes[classes];
    //     int nearest[k];
    //
    //     // Combination in the ensemble always be means of majority voting
    //     for (int i = 0; i < classes; i++)
    //         votes[i] = 0.0;
    //
    //     switch (classifier) {
    //         case kNN:
    //             for (int i = 0; i < size; i++)
    //                 votes[kNNClassification(pattern, data, subspaces[i+first], instances, k, inputs, labels, classes, sampling_size, nearest)] += alpha[i+first];
    //             break;
    //
    //         case C45:
    //             for (int i = 0; i < size; i++)
    //                 votes[C45OutputSubspace(trees[i], pattern, subspaces[i+first], inputs)] += alpha[i+first];
    //             break;
    //
    //         case SVM:
    //             for (int i = 0; i < size; i++)
    //                 votes[SVMOutputSubspace(svms[i], pattern, inputs, subspaces[i+first])] += alpha[i+first];
    //             break;
    //
    //         default:
    //             OnErrorExit(1, "I should not be here");
    //     }
    //
    //     // Get maximum number of votes
    //     int category = 0;
    //     for (int i = 1; i < classes; i++)
    //         if (votes[i] > votes[category])
    //             category = i;
    //
    //     return category;
    return 0;
}
