/***************************************************************************
 *   Copyright (C) 2009 by Aida de Haro-García                             *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
   Definitions and prototypes for genetic algorithm applied to feature selection
 */
#ifndef _GAFS_H
#define _GAFS_H
#include "fs.h"

void GenerateRandomPopulation(int **, int, int, scalar);
void Generation(const t_Parameters *, int ** *, int ** *, scalar **, scalar **, int, int, int, scalar, scalar, scalar, scalar **, int, int *, int, int);
scalar EvaluateInd(const t_Parameters *, int *, int, scalar, scalar **, int, int *, int, bool, int);
void EvaluateAll(const t_Parameters *, int **, scalar *, int, int, scalar, scalar **, int, int *, int, bool, int);
void FitnessArrangement(int **, scalar *, int, int);
void TwoPointCrossoverGA(int *, int *, int *, int *, int);
void InsertTwoBest(const t_Parameters *, int **, int **, scalar *, scalar *, scalar *, int, int, int *, int *, int, scalar, int, scalar **, int, int *, int, int);
void Mutation(const t_Parameters *, int **, int, int, scalar, scalar, scalar *, scalar, scalar **, int, int *, int, int);
void GeneticAlgorithm(const t_Parameters *, int *, int, scalar, int, int, scalar, scalar, scalar, scalar, scalar **, int, int *, int, int);
int TournamentSelectionGA(scalar *, int);
int RouletteSelection(scalar *, int);


#endif /*_GAFS_H */
