/***************************************************************************
 *   Copyright (C) 2008 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// Definitions and prototypes
#ifndef _RANKING_H
#define _RANKING_H

#include <stdio.h>
#include <time.h>
#include <stdbool.h>
#include "fs.h"
#include "typex.h"
#include "common.h"
#include "defns.i"
#include "types.i"
#include "svm.h"
#include "is.h"

// Feature ranking algorithms
void FeatureRankingAlgorithm(const t_Parameters *, t_FRAlgorithm, int, scalar **, int *, int, int, int, t_RankInfo *, scalar **, int *, int **);
void ChiSquareFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *, int **);
void UnbalancedCorrelationScore(const t_Parameters *, int, scalar **, int *, int, int, int, t_RankInfo *, int **);
void DifferentialShannonEntropyFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *);
void EuclideanDistanceBasedEntropy(const t_Parameters *, int, scalar **, int, t_RankInfo *, int **);
void FScore(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *);
void FisherScore(const t_Parameters *, int, scalar **, int *, int, int, int, t_RankInfo *, int **);
void InformationGainFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *, int **);
void MutualInformationFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *, scalar **, int *, int **);
void ShannonEntropyFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *);
void SecondOrderMutualInformationFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *);
void SingularValueDecompositionEntropy(const t_Parameters *, int, scalar **, int, t_RankInfo *);
void tTestBasedFeatureRanking(const t_Parameters *, int , scalar **, int *, int, int, t_RankInfo *, int **);
void WilcoxonTestBasedFeatureRanking(const t_Parameters *, int, scalar **, int *, int, int, t_RankInfo *);
void RFE(const t_Parameters *, t_Feat *, int, scalar **, int, int *, int *);
int CompareRanking(const void *, const void *);
int CompareIndex(const void *, const void *);
int CompareWInv(const void *, const void *);

/* simba.c */
void IterativeSearchMarginBasedAlgorithm(const t_Parameters *, scalar **, int, int, int *, t_RankInfo *);
void NearMissHitW(int, scalar **, int, int, int *, int *, int *, scalar *);
scalar WeightedEuclideanDistance(scalar *, scalar *, int, scalar *);

#endif              /* !_RANKING_H */
