/***************************************************************************
 *   Copyright (C) 2009 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "fs.h"

// Functions to deal with subspaces

// Test if there is an existing subspace equal to the current one
// Otherwise return -1
int GetSameSubspace(int *subspace, int **s, int n, int features)
{
    for (int i = n - 1; i >= 0; i--) {
        bool equal = true;
        for (int j = 0; j < features; j++)
            if (subspace[j] != s[i][j]) {
                equal = false;
                break;
            }

        if (equal)
            return i;
    }

    // If here there is no subspace like this one
    return -1;
}
