/*
   Data types and prototypes
 */
#pragma once

// Function prototypes
void OversampleData (scalar ***, int *, int, int, int **, scalar);
void UndersampleData (scalar ***, int *, int, int, int **, int);
void ClusterBasedUndersampling(scalar ***, int *, int, int, int **);
void MulticlassUndersampleData(scalar ***, int *, int, int, int **, int);
void SMOTEOverSampling (scalar ***, int *, int, int, int **, int, int);
void GetkNearestNeighbours (scalar *, int *, scalar **, int, int, int, int *);
void kMeansForUndersampling(int *clusters, int *count, scalar **data, int instances, int k, int inputs, int kmeans_max_iterations);
/* ci-stub.c */
void ClassImbalanceMethodFor2Class(const t_Parameters *, scalar ***, int *, int, int, int **);
void ClassImbalanceMethodFor2ClassNoStratified(const t_Parameters *, scalar ***, int *, int, int, int **);
void SaveDatasetAsARFFForSampling(char *, int, scalar **, int, int **, int *, int);
void RunExternalCIMethod(char *, scalar ***, int **, int *, int, int);
/* evosmote.c */
void EvolutionarySMOTE(const t_Parameters *, scalar  ***, int *, int ***, int, int, int **, int *, int *, int *);
int AddInstances(scalar **, int, int, int *, int *, int, int *, scalar *, int, int, int **, int, int *, bool);
void BLXAlphaCrossoverReal(scalar *, scalar *, scalar *, scalar *, int, scalar, scalar);
void GetkNeighborsForSMOTE(scalar *, scalar **, int *, int, int, int, int *, int *, int **, int *, bool, int, cache_t *, int *);
void UpdateCacheWithOversampledData(scalar **, int, int, int, scalar **, cache_t **, int **, int *, bool);
void ListOfNearestNeighborsAndMinimumDistance(int *, scalar *, scalar **, int, int, int, bool, int *, scalar *, int **, int *, bool, int *, int *, int);
scalar EvoSMOTEEvaluateFitness(const t_Parameters *, scalar **, int, int, int *, int *, int, int *, scalar *, int, int **, int, cache_t **, int *, int *, int **, scalar *, int *, scalar *, int, int,
                               scalar *, int, scalar *);
int RemoveUnselectedInstances(scalar ***, int *, int **, int ***, int *);
void InitializePopulation(const t_Parameters *, int **, int **, scalar **, int *, int, int, int, int, int, int *, int **, scalar **, int, int, int *, int *, int, int, int);
/* evoops.c */
void NonUniformMutationReal(scalar *, int, int, int, double, scalar, scalar);
void EvoSMOTECrossover(int *, int *, int *, int *, int, scalar *, scalar *, scalar *, scalar *, int);
void RandomUndersamplingMutation (int *, int, scalar, int *, int, int *, int, int, int);
int NoisyMinorityClassInstancesMutation(scalar **, int, int *, int, int, int *, int *, int, int **, int);
scalar EuclideanDistanceWithMinimum(scalar *, scalar *, int, scalar);
