/***************************************************************************
 *   Copyright (C) 2011 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdlib.h>
#include <stdbool.h>
#include "is.h"
#include "macros.h"
#include "common.h"
#include <unistd.h>

// Functions for standard methods for class-imbalanced datasets
// These methods are implemented as instance selection methods


// Randomly undersample majority class
int RandomUndersampling(int *S, int instances, int *label, int minority, scalar ratio)
{
    int count[] = {0, 0}, selected, *list_M, M = 0;

    // Count class distribution
    ALLOCA(list_M, int, instances, "RandomUndersampling: list_M");
    for (int i = 0; i < instances; i++) {
        count[label[i]]++;

        if (label[i] != minority) {
            list_M[M] = i;
            M++;
            S[i] = 0;
        } else
            S[i] = 1;
    }

    selected = count[minority];

    // Undersample
    RandomizeVector(list_M, M);
    for (int i = 0; i < count[minority]*ratio && i < M; i++) {
        S[list_M[i]] = 1;
        selected++;
    }

    return selected;
}
