/***************************************************************************
 *   Copyright (C) 2010 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
// Functions that deal with the population of individuals

#include <stdio.h>
#include <string.h>
#include "is.h"
#include "macros.h"
#include "common.h"

void CreateInitialPopulation(int ***population, int individuals, int n_subpops, int subpop_size)
{

    // Allocate memory for individuals
    MALLOC(*population, int *, individuals, "CreateInitialPopulation: g_individual");

    // Create individuals
    for (int i = 0; i < individuals; i++) {
        MALLOC((*population) [i], int, n_subpops, "CreateInitialPopulation: (*population)[i]");
        for (int j = 0; j < n_subpops; j++)
            (*population) [i][j] = RANDOM(0, subpop_size);
    }
}

scalar EvaluateIndividual(int *individual, int indiv, cache_t **dist_cache, int instances, int *train_labels)
{
    /*scalar ok = 0, reduction;
    int nearest = 0, selected;
    static int *sample = NULL;*/

    OnErrorExit(1, "This function must be updated to account for the new definition of NearestNeighbourCache");

    // Count the prototypes on every individual
    /*selected = 0;
    for (int i = 0; i < gl_n_subpops; i++)
        for (int j = 0; j < gl_limits[i].size; j++)
            if (gl_subpopulation[i][individual[i]][j])   // {
                //              sample[selected] = gl_limits[i].init+j;
                selected++;
    //          }

    // If reduction is 100% return 0 fitness
    if (selected == 0) {
        gl_objectives[indiv][REDUCTION] = gl_objectives[indiv][OK] = 0.0;
        return 0.0;
    }

    reduction = 1.0 - ((scalar) selected)/instances;

    gl_objectives[indiv][REDUCTION] = reduction;

    // Evaluate error
    if (gl_ok_w > ZERO)
        for (int i = 0; i < instances; i++)
            if (NearestNeighbourCache(i, individual, selected, &nearest, train_labels, dist_cache, NULL, -1) == train_labels[i])
                ok++;

    ok /= instances;

    gl_objectives[indiv][OK] = ok;

    return gl_ok_w * ok+gl_reduction_w * reduction;*/

    return 0.0;
}


void MutateIndividual(int *individual, int n_subpops, int subpop_size)
{
    // Select a random subpopulation and modify the individual
    individual[(int) RANDOM(0, n_subpops) ] = RANDOM(0, subpop_size);
}

scalar EvaluateAccuracy(int *individual, scalar **data, int instances, int *label, int inputs)
{
    /*int index = 0, nearest, *sample;
    scalar ok = 0;*/

    OnErrorExit(1, "This function must be updated to account for the new definitions");

    /*ALLOCA(sample, int, gl_limits[0].size, "EvaluateAccuracy: sample");

    // Create prototypes mask
    for (int i = 0; i < gl_n_subpops; i++)
        for (int j = 0; j < gl_limits[i].size; j++) {
            sample[index] = gl_subpopulation[i][individual[i]][j];
            index++;
        }

    // Evaluate error
    for (int i = 0; i < instances; i++)
        if (NearestNeighbour(data[i], sample, data, instances, inputs, &nearest, label) == label[i])
            ok++;

    return ok/instances;*/

    return 0.0;
}
