// Types and prototypes for common functions
#ifndef _KCLUSTERING_H
#define _KCLUSTERING_H
#include "common.h"
#include "kd.h"

//KdTrees prototypes
tKDTREE *MakeTree(scalar **, scalar ** *, scalar ** *, int, int, int, int *);
void FindNearNeighbours(scalar *, /*nodePREVNN **, */ scalar *, scalar *,
                        /*scalar *left_max, scalar *left_min, scalar *right_max, scalar *right_min, */
                        tNN * , tKDTREE *, int *, int);

//List functions
void recursiveFreeInvList(nodeINV **);
void recursiveFreeSimList(nodeSIM **);
void recursiveFreeIdList(nodeID **);
nodeINV *list_add_inv(nodeINV **, int, int);
void list_print_inv(nodeINV *);
nodeSIM *list_add_sim(nodeSIM **, int);
void list_print_sim(nodeSIM *);
nodeSIM *list_search_sim(nodeSIM *, int);
void list_add_id(nodeID **, nodeID **, int, int);
void list_add_first_ident(nodeID **, int);
nodePREVNN *list_add_prev(nodePREVNN **, int, scalar, scalar, scalar, scalar);
void list_print_prev(nodePREVNN *);
void recursiveFreePrevList(nodePREVNN **);

//Clustering steps functions
void CreateNeighbourhoodTable(scalar **, nodePREVNN **, tNN ** *, tNN *, tKDTREE *, int, int, int);
void CreateInvertedList(nodeINV ** *, tNN **, int, int);
void CreateSimilarityList(nodeSIM ** *, nodeINV **, int);
void CreateIdentityList(nodeID ** *, nodeINV ** *, nodeSIM **, int, int);
void LabelElements(nodeID **, int *, tCLST **, int *, int *, int **, int **, int);
void kdClust(scalar **, int, int *, int *, int *, tCLST ** , int **, int **, int, int, int, int);
void kdTreeClusteringAlgorithm(const t_Parameters *, int *, int *, int *, scalar **, int, int, int, int, int);


#endif                          // _KCLUSTERING_H
