/***************************************************************************
 *   Copyright (C) 2015 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
// Functions that deal with the individuals
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include "is.h"
#include "macros.h"
#include "common.h"

bool StopCriterionMet(const t_Parameters *parm, time_t used_time, scalar evaluations, int generation)
{
    // If time limit end
    if (parm->time_limit && used_time > parm->time_limit) {
        fprintf(parm->out_file, "Reached time limit at generation: %d\n", generation+1);
        return true;
    }

    // If maximum evaluations end
    if (parm->max_evaluations && (evaluations > parm->max_evaluations)) {
        fprintf(parm->out_file, "Reached evaluations limit at generation: %d\n", generation+1);
        return true;
    }

    return false;
}
