/***************************************************************************
 *   Copyright (C) 2010 by Nicolas Garcia-Pedrajas and                     *
 *   Juan Antonio Romero del Castillo                                      *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "common.h"
#include "macros.h"
// Select instances depending on threshold

int SelectInstancesUsingThreshold(scalar *votes, int instances, int *S, int *list, int *selected, int threshold, bool multiselection, int k)
{
    int sel_instances = 0;

    *selected = 0;

    // Select depending on CHC multi-instance
    if (multiselection) {
        // Allow more than one copy
        for (int i = 0; i < instances; i++)
            if (votes[i] >= threshold) {
                sel_instances++;
                int count = MIN(votes[i]/threshold, k/2+1);
                for (int j = 0; j < count; j++) {
                    list[*selected] = i;
                    (*selected) ++;
                }
            }
    } else {
        for (int i = 0; i < instances; i++)
            if (votes[i] >= threshold) {
                list[*selected] = i;
                (*selected) ++;
                sel_instances++;
            }
    }

    // If S non NULL store selection
    if (S != NULL) {
        for (int i = 0; i < instances; i++)
            S[i] = 0;

        for (int i = 0; i < *selected; i++)
            S[list[i]]++;
    }

    return sel_instances;
}
