/***************************************************************************
 *   Copyright (C) 2017 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "macros.h"
#include "common.h"

// For rotation of vectors
#define SET     1
#define INIT    2
#define NEXT    3
#define CLEAR   4

// Prototypes
/* vectors.c */
void getVec(int OP, ...);
void nextAlpha(int, int, scalar, scalar *, scalar *next, scalar *);
void applyRotation(int, scalar *, scalar *);
scalar norm(int, scalar *);
void normalize(int, scalar *);
void zeros(int, scalar *);
void ones(int, scalar *);
void printvec(int, scalar *);
void randvecOfAngles(int, scalar *);
void randvec(int, scalar *);
scalar EuclideanDistanceSparseData(scalar *, scalar *, int, int *, int *);
scalar SqEuclideanDistance(scalar *, scalar *, int);
scalar EuclideanDistance(scalar *, scalar *, int);
scalar EuclideanDistanceSparseDataSubspace(scalar *, scalar *, int, int *, int *, int *);
scalar SumVector(scalar *, int *, int);
int MaxVectorIndex(scalar *, int *, int);
scalar AverageScalarVector(scalar *, int);
scalar AverageIntegerVector(int *, int);
scalar SumColumn(scalar **, int, int);
scalar AverageIntegerMatrix(int **, int, int);
bool EmptyRow(int *, int);
bool EmptyColumn(int **, int, int);
scalar MinkowskiDistance(scalar *, scalar *, int, scalar, int *);
scalar MinkowskiDistanceSparse(scalar *, scalar *, int n, scalar, int *, int *, int *);
scalar MinkowskiDistanceSparseDense(scalar *, scalar *, int, scalar, int *, int *);
scalar MaximumOfMatrixColumn(scalar **, int **, int, int);
/* pca.c */
void PrincipalComponentsAnalysis(scalar **, int, int, int, scalar ** *, scalar **);
/* poisson.c */
int PoissonRandomNumber(int lambda);
scalar Poisson(void);
/* matrix.c */
void InvertMatrix(scalar **, scalar **, int);
scalar MatrixDeterminant(scalar **, int);
void MaskedMatrixVectorProduct(scalar **, scalar *, scalar *, int, int *);
scalar MaskedDotProduct(scalar *, scalar *, int, int *);
void PrintMatrix(scalar **, int, int, FILE *, int, int);
scalar MaximumOfVector(scalar *, int);
int MaximumOfIntegerVector(int *, int);
int IndexOfMaximumOfIntegerVector(int *, int);
int IndexOfMaximumOfScalarVector(scalar *, int);
int MinimumOfIntegerVector(int *, int);
int RouletteSelection(scalar *, int);
void PrintVector(scalar *, int *, int, FILE *);
int IndexOfMinimumOfVector(scalar *, int *, int);
bool CheckMatrix(scalar **, int, int);
bool CheckVector(scalar *, int);
void CompactVector(scalar *, int *, int *);
void ZeroScalarMatrix(scalar **, int, int);
void FillMatrix(scalar **, int **, int, int, scalar);
void CopyIntegerMatrix(int **, int **, int, int);
void OrIntegerMatrix(int **, int **, int, int);
