/***************************************************************************
 *   Copyright (C) 2011 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// Definition for dealing with DNA sequences and string kernels

/* Codification for string kernels:
                A       0001
                T/U     0010
                G       0100
                C       1000
                R       0101 (A or G, purine)
                Y       1010 (T/U or C, pyrimidine)
                K       0110 (G or T/U, ketone)
                M       1001 (A or C, amino group)
                S       1100 (G or C, strong interaction)
                W       0011 (A or T, weak interaction)
                B       1110 (Not A)
                D       0111 (Not C)
                H       1011 (Not G)
                V       1101 (Not T, not U)
                N       0000 (Any)
                X       0000 (Masked)
                -       0000 (Gap)
                -       1111 (No info)
*/

char DNA_reverse_coding[2][2][2][2] = {

     {{{'N','A'}, {'T','W'}}, {{'G','R'}, {'K','D'}}},
     // {{{0000,0001}, {0010,0011}}, {{0100,0101}, {0110,0111}}},
     {{{'C','M'}, {'Y','H'}}, {{'S','V'}, {'B','N'}}}
     // {{{1000,1001}, {1010,1011}}, {{1100,1101}, {1110,1111}}}
};
